# Releasing a new version of terraform-provider-openapi

Terraform Provider OpenAPI performs releases automatically via Travis CI. 

## Pre-requirements

- [Go 1.12.4](https://golang.org/)
- [GoReleaser](https://goreleaser.com/)
- [Github Release Notes](https://github.com/buchanae/github-release-notes)

## How to release a new version

This project uses [semantic version 2.0.0](https://semver.org/) and tags are created following this pattern (MAJOR.MINOR.PATCH). To
create a new version follow the steps below:

### Check the latest version released

````
$ make latest-tag
[INFO] Latest tag released...
v0.1.0
````

### Update version file

Per the latest version released, determine whether the new version is a major, minor, or patch and update the 
[version file](https://github.com/dikhan/terraform-provider-openapi/blob/master/version) accordingly. For instance, given 
the above latest-tag output (v0.1.0), if we wanted to release a new minor version, the content of the version file should be 
`0.2.0`. Then follow the regular [process for contributing code](https://github.com/dikhan/terraform-provider-openapi/blob/master/.github/CONTRIBUTING.md#contributing-code)
to push the changes:

To confirm the new version to be released:
````
$ cat version 
0.2.0
````

Note - For new releases, the PR title should follow the below convention (replace 0.2.0 with the new version):

```
[NewRelease] v0.2.0
```

With the above title, the new version would be v0.2.0.

The PR will need one admin approval. Once approved and merged, the release will be automatically performed by Travis CI.